Page MenuHomeFreeBSD

msdosfs: fixes for Undefined Behavior.
ClosedPublic

Authored by pfg on Aug 7 2018, 3:48 PM.

Details

Reviewers
emaste
delphij
Summary

These were found by the Undefined Behaviour GsoC project at NetBSD:

Do not change signedness bit with left shift.
While there avoid signed integer overflow.
Address both issues with using unsigned type.

msdosfs_fat.c:512:42, left shift of 1 by 31 places cannot be represented
in type 'int'
msdosfs_fat.c:521:44, left shift of 1 by 31 places cannot be represented
in type 'int'
msdosfs_fat.c:744:14, left shift of 1 by 31 places cannot be represented
in type 'int'
msdosfs_fat.c:744:24, signed integer overflow: -2147483648 - 1 cannot be
represented in type 'int [20]'
msdosfs_fat.c:840:13, left shift of 1 by 31 places cannot be represented
in type 'int'
msdosfs_fat.c:840:36, signed integer overflow: -2147483648 - 1 cannot be
represented in type 'int [20]'

Detected with micro-UBSan in the user mode.

Hinted from: NetBSD

Diff Detail

Repository
rS FreeBSD src repository
Lint
Lint OK
Unit
No Unit Test Coverage
Build Status
Buildable 18626
Build 18315: arc lint + arc unit

Event Timeline

pfg created this revision.Aug 7 2018, 3:48 PM
pfg added a reviewer: delphij.Aug 8 2018, 4:27 AM
delphij accepted this revision.Aug 8 2018, 5:00 AM

LGTM. Thanks!

This revision is now accepted and ready to land.Aug 8 2018, 5:00 AM
pfg closed this revision.Apr 27 2019, 2:34 PM

This was committed as r337456.